<?php
/**
 * ------------------------------------------------------------------------
 * JA Smashboard Template
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2011 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - Copyrighted Commercial Software
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites:  http://www.joomlart.com -  http://www.joomlancers.com
 * This file may not be redistributed in whole or significant part.
 * ------------------------------------------------------------------------
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

define('QS_CACHE_PATH', JPATH_CACHE . '/quicksearch');
define('QS_IMG_WIDTH', 64);
define('QS_IMG_HEIGHT', 64);

jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');
jimport('joomla.image.image');

class SMBHelper {

	public static function getYTImage($item){
		$result = '';
		
		if(preg_match_all('@<iframe\s[^>]*src=[\"|\']([^\"\'\>]+)[^>].*?</iframe>@ms', $item->introtext, $iframesrc) > 0){
			if(isset($iframesrc[1])){
				$vid = str_replace(
					array(
						'http:',
						'https:',
						'//youtu.be/',
						'//www.youtube.com/embed/',
						'//youtube.googleapis.com/v/'), '', $iframesrc[1][0]);
				
				$vid = preg_replace('@(\/|\?).*@i', '', $vid);
				
				if(!(empty($vid))){ 
					
					$result = '' .
						'<div class="vimage">
							<a class="video-link vlink" href="'.JRoute::_(ContentHelperRoute::getArticleRoute($item->slug, $item->catid)).'" title="">
								<img src="http://img.youtube.com/vi/'.$vid.'/0.jpg" />
								<span class="play-icon">&nbsp;</span>
							</a>		
						</div>';
					
					$item->introtext = str_replace($iframesrc['0'], '', $item->introtext);
				}else{
					
					if (!strpos($iframesrc[1][0],'player.vimeo.com') === false) {
						$thumb = preg_replace('|(player.vimeo.com/video/([a-zA-Z0-9_-]+))|e', 'SMBHelper::vimeoThumb("\2")', $iframesrc[1][0]);
					}else if(!strpos($iframesrc[1][0],'vimeo.com') === false){
						$thumb = preg_replace('|(vimeo.com/([a-zA-Z0-9_-]+))|e', 'SMBHelper::vimeoThumb("\2")', $iframesrc[1][0]);
					}else{
						$thumb = '';
					}
					$imgpath= SMBHelper::getVimeoThumb($thumb);
					if($imgpath){
						$result = '' . 
						'<div class="vimage">
							<a class="video-link vlink" href="'.JRoute::_(ContentHelperRoute::getArticleRoute($item->slug, $item->catid)).'" title="">
								<img src="'.$imgpath.'" />
								<span class="play-icon">&nbsp;</span>
							</a>
						</div>';

						$item->introtext = str_replace($iframesrc['0'], '', $item->introtext);
					}
				}
			}
		}

		return $result;
	}

	public static function getYTK2Image($item){
		$result = '';

		if(!empty($item->video)){
			if(preg_match_all('@<iframe\s[^>]*src=[\"|\']([^\"\'\>]+)[^>].*?</iframe>@siu', $item->video, $iframesrc) > 0){
				
				if(isset($iframesrc[1])){
					$vid = str_replace(
						array(
							'http://youtu.be/',
							'http://www.youtube.com/embed/',
							'http://youtube.googleapis.com/v/'), '', $iframesrc[1][0]);
					
					
					$vid = preg_replace('@\/.*?@i', '', $vid);

					if(!(empty($vid))){
						$result = ''.
							'<div class="vimage">
								<a class="video-link vlink" href="'.$item->link.'" title="">
									<img src="http://img.youtube.com/vi/'.$vid.'/0.jpg" />
									<span class="play-icon">&nbsp;</span>
								</a>
							</div>';
					}else{
						if (!strpos($iframesrc[1][0],'player.vimeo.com') === false) {
							$thumb = preg_replace('|(player.vimeo.com/video/([a-zA-Z0-9_-]+))|e', 'SMBHelper::vimeoThumb("\2")', $iframesrc[1][0]);
						}else if(!strpos($iframesrc[1][0],'vimeo.com') === false){
							$thumb = preg_replace('|(vimeo.com/([a-zA-Z0-9_-]+))|e', 'SMBHelper::vimeoThumb("\2")', $iframesrc[1][0]);
						}else{
							$thumb = '';
						}
						$imgpath= SMBHelper::getVimeoThumb($thumb);
						if($imgpath){
							$result = '' . 
							'<div class="vimage">
								<a class="video-link vlink" href="'.$item->link.'" title="">
									<img src="'.$imgpath.'" />
									<span class="play-icon">&nbsp;</span>
								</a>
							</div>';

							$item->introtext = str_replace($iframesrc['0'], '', $item->introtext);
						}
					}
				}
			}

		} else {
			// check video in introtext;
			if(preg_match_all('@<iframe\s[^>]*src=[\"|\']([^\"\'\>]+)[^>].*?</iframe>@siu', $item->introtext, $iframesrc) >0){
				if(isset($iframesrc[1])){
					$vid = str_replace(
						array(
							'http://youtu.be/',
							'http://www.youtube.com/embed/',
							'http://youtube.googleapis.com/v/'), '', $iframesrc[1][0]);
					
					$vid = preg_replace('@\/.*?@i', '', $vid);
					
					if(!(empty($vid))){
						$result = '' . 
							'<div class="vimage">
								<a class="video-link vlink" href="'.$item->link.'" title="">
									<img src="http://img.youtube.com/vi/'.$vid.'/0.jpg" />
									<span class="play-icon">&nbsp;</span>
								</a>
							</div>';

						$item->introtext = str_replace($iframesrc['0'], '', $item->introtext);
					}else{
						if (!strpos($iframesrc[1][0],'player.vimeo.com') === false) {
							$thumb = preg_replace('|(player.vimeo.com/video/([a-zA-Z0-9_-]+))|e', 'SMBHelper::vimeoThumb("\2")', $iframesrc[1][0]);
						}else if(!strpos($iframesrc[1][0],'vimeo.com') === false){
							$thumb = preg_replace('|(vimeo.com/([a-zA-Z0-9_-]+))|e', 'SMBHelper::vimeoThumb("\2")', $iframesrc[1][0]);
						}else{
							$thumb = '';
						}
						$imgpath= SMBHelper::getVimeoThumb($thumb);
						if($imgpath){
							$result = '' . 
							'<div class="vimage">
								<a class="video-link vlink" href="'.$item->link.'" title="">
									<img src="'.$imgpath.'" />
									<span class="play-icon">&nbsp;</span>
								</a>
							</div>';

							$item->introtext = str_replace($iframesrc['0'], '', $item->introtext);
						}
					}
				}
			}
		}

		return $result;
	}
	public static function vimeoThumb($vCode){
        return 'vimeo.com/api/v2/video/'.$vCode.'.json';
    }
    public static function getVimeoThumb($data) {
		if(!$data) return;
		$data = SMBHelper::validURL($data);
        $data = file_get_contents($data);
        $data = json_decode($data);
        return $data[0]->thumbnail_large;
    }
	
	public function validURL($url){
        if ((strpos($url,'http') === false)) {
			$url = 'http:'.$url;
		}else{
			return $url;
		}
		return $url;
    }
	
	public static function getQSCache($src){

		//has protocol
		if (strpos($src, '://') !== false || !JFile::exists(JPATH_ROOT . '/' . $src)){
			return $src;
		}

		if(!JFolder::exists(QS_CACHE_PATH)) {
			JFolder::create(QS_CACHE_PATH);
		}

		$filename = md5($src) . '.' . pathinfo($src, PATHINFO_EXTENSION);

		if(!JFile::exists(QS_CACHE_PATH . '/' . $filename)) {
			
			$props = JImage::getImageFileProperties(JPATH_ROOT . '/' . $src);
			$image = new JImage(JPATH_ROOT . '/' . $src);
			// Resize image
			$image->resize(QS_IMG_WIDTH, QS_IMG_HEIGHT, false, JImage::SCALE_OUTSIDE);
			$left = abs(($image->getWidth()  - QS_IMG_WIDTH) / 2);
			$top  = abs(($image->getHeight() - QS_IMG_HEIGHT) / 2);
			
			// Crop image
			$image->crop(QS_IMG_WIDTH, QS_IMG_HEIGHT, $left, $top, false);
			
			// Save image
			$type = '';
			switch ($props->mime)
			{
				case 'image/gif':
					$type = IMAGETYPE_GIF;
					break;
				case 'image/png':
					$type = IMAGETYPE_PNG;
					break;
				case 'image/jpeg':
					$type = IMAGETYPE_JPEG;
					break;
				default:
			}
			
			if (empty($type)) {
				return false;
			} 

			$image->toFile(QS_CACHE_PATH . '/' . $filename, $type);
		}

		return JURI::base(true) . '/cache/quicksearch/' . $filename;
	}
}